﻿using LaserBlasterTag.scenes;
using LaserBlasterTag.utility;
using Otter;

namespace LaserBlasterTag
{
    class Program
    {
        static void Main(string[] args)
        {
            Global.GAME = new Game("LaserBlasterTag", 1440, 960);
            Global.GAME.MouseVisible = true;
            Global.GAME.SetWindow(1440, 960);
            var app = Global.PlayerSession = Global.GAME.AddSession("Player");
            app.Controller.AddButton("Enter");
            app.Controller.Button("Enter").AddKey(Key.Return);
            app.Controller.AddButton("W");
            app.Controller.Button("W").AddKey(Key.W);
            app.Controller.AddButton("A");
            app.Controller.Button("A").AddKey(Key.A);
            app.Controller.AddButton("S");
            app.Controller.Button("S").AddKey(Key.S);
            app.Controller.AddButton("D");
            app.Controller.Button("D").AddKey(Key.D);
            app.Controller.AddButton("M");
            app.Controller.Button("M").AddKey(Key.M);
            app.Controller.AddButton("Up");
            app.Controller.Button("Up").AddKey(Key.Up);
            app.Controller.AddButton("Down");
            app.Controller.Button("Down").AddKey(Key.Down);
            app.Controller.AddButton("Right");
            app.Controller.Button("Right").AddKey(Key.Right);
            app.Controller.AddButton("Left");
            app.Controller.Button("Left").AddKey(Key.Left);
            app.Controller.AddButton("R");
            app.Controller.Button("R").AddKey(Key.R);
            app.Controller.AddButton("E");
            app.Controller.Button("E").AddKey(Key.E);
            app.Controller.AddButton("Q");
            app.Controller.Button("Q").AddKey(Key.Q);
            app.Controller.AddButton("Space");
            app.Controller.Button("Space").AddKey(Key.Space);
            app.Controller.AddButton("LeftMouseClick");
            app.Controller.Button("LeftMouseClick").AddMouseButton(MouseButton.Left);
            app.Controller.AddButton("RightMouseClick");
            app.Controller.Button("RightMouseClick").AddMouseButton(MouseButton.Right);

            new SoundManager();
            Global.GAME.FirstScene = new TitleScreen(); //uncomment at relase! or further testing! haha! //testing
            //Global.GAME.FirstScene = new OneRoom();
            //Global.GAME.FirstScene = new RedWinScreen();
            Global.GAME.Start();
        }
    }
}
