﻿using LaserBlasterTag.entities.lasers;
using Otter;
using System;

namespace LaserBlasterTag.entities.teams
{
    public class RedTeam : Entity
    {
        private Spritemap<string> _spriteMap;
        private bool isTimeToMove = true;
        private bool stand = false;
        private int rand = 0;
        private int walkTimer = 0;
        private int standTimer = 0;
        private float forcedSpeed = Otter.Rand.Float(.05f, .1f);
        private bool _first = true;
        private bool _canCollideRedPlayers = false;
        public BasicMovement Movement = new BasicMovement(1600, 1600, 1600);
        private bool _hMove = false;
        private bool _vMove = false;
        private bool _setAnimOnce = true;
        private int _redHealth = 2;
        private int _fireTimer = Otter.Rand.Int(40, 100);
        public RedTeam(float x, float y)
        {
            X = x; Y = y;
            SetHitbox(8, 20, (int)Global.Type.REDPLAYER);
            Collider.X = 20;
            Collider.Y = 16;
            Axis axis = Axis.CreateArrowKeys();
            Movement.Axis = axis;
            Movement.Axis.AddKeys(Key.W, Key.D, Key.S, Key.A);//you could use this to add your own keys for moving the character! :-)
            Movement.Collider = Collider;
            Movement.AddCollision((int)Global.Type.SOLID);
            Movement.AddCollision((int)Global.Type.BLUEPLAYER);
            Movement.AddCollision((int)Global.Type.REDBASE);
            Movement.AddCollision((int)Global.Type.BLUEBASE);
            AddComponents(axis, Movement);
            _spriteMap = new Spritemap<string>(Assets.REDPLAYER, 46, 56);
            addNewSprites();
            _spriteMap.Play("standRight");
            Graphic = _spriteMap;
            Movement.Axis.Locked = true;
        }
        public override void Update()
        {
            base.Update();
            if (_first)
            {
                _first = false;
                if (Collider.Collide(X, Y, (int)Global.Type.SOLID) != null)//am i colliding with a solid?
                {
                    Scene.Add(new RedTeam(Otter.Rand.Int(Global.GAME.Width - 150, Global.GAME.Width - 64), Otter.Rand.Int(8, Global.GAME.Height - 64)));
                    destroy();
                }
            }
            #region Movement
            if (isTimeToMove)
            {
                isTimeToMove = false;
                walkTimer = Otter.Rand.Int(30, 101);
                forcedSpeed = Otter.Rand.Float(.05f, .1f);
                rand = getRandomNumber();
                _setAnimOnce = true;
            }
            if (walkTimer > 0)
            {
                walkTimer--;
                switch (rand)
                {
                    case (int)move.up:
                        Movement.Axis.ForceStateY(-forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 23, Y + 29, "Up", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkUp");
                        }
                        break;
                    case (int)move.upRight:
                        Movement.Axis.ForceState(forcedSpeed, -forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 27, Y + 26, "Right", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkRight");
                        }
                        break;
                    case (int)move.right:
                        Movement.Axis.ForceStateX(forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 27, Y + 26, "Right", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkRight");
                        }
                        break;
                    case (int)move.downRight:
                        Movement.Axis.ForceState(forcedSpeed, forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 27, Y + 26, "Right", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkRight");
                        }
                        break;
                    case (int)move.down:
                        Movement.Axis.ForceStateY(forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 23, Y + 33, "Down", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkDown");
                        }
                        break;
                    case (int)move.downLeft:
                        Movement.Axis.ForceState(-forcedSpeed, forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 19, Y + 26, "Left", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkLeft");
                        }
                        break;
                    case (int)move.left:
                        Movement.Axis.ForceStateX(-forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 19, Y + 26, "Left", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkLeft");
                        }
                        break;
                    default://upleft
                        Movement.Axis.ForceState(-forcedSpeed, -forcedSpeed);
                        if (_fireTimer <= 0)
                        {
                            _fireTimer = Otter.Rand.Int(40, 100);
                            Scene.Add(new RedLaser(X + 19, Y + 26, "Left", this));
                        }
                        if (_setAnimOnce)
                        {
                            _setAnimOnce = false;
                            _spriteMap.Play("walkLeft");
                        }
                        break;
                }
                _vMove = true;
                _hMove = true;
            }
            if (!stand && walkTimer <= 0)
            {
                stand = true;
                Movement.Axis.ReleaseState();
                standTimer = Otter.Rand.Int(40, 101);
                if (!_canCollideRedPlayers)
                {
                    checkIfCollidingWithRedPlayer();
                }
            }
            if (stand && standTimer > 0)
            {
                _hMove = false;
                _vMove = false;
                standTimer--;
            }
            if (stand && standTimer <= 0)
            {
                stand = false;
                isTimeToMove = true;
            }
            if (_fireTimer > 0)
                _fireTimer--;
            stopWalkingAnimations();
            #endregion
            var collBlueLaser = Collider.Collide(X, Y, (int)Global.Type.BLUELASER);
            if (collBlueLaser != null)
            {
                BlueLaser r = (BlueLaser)collBlueLaser.Entity;
                r.destroy();
                _redHealth--;
                _spriteMap.Play("hit");
            }
            if (_redHealth <= 0)
            {
                Scene.Add(new RedTeam(1380, 8));
                destroy();
            }
        }

        private void checkIfCollidingWithRedPlayer()
        {
            if (Collider.Collide(X, Y, (int)Global.Type.REDPLAYER) != null)
                return;
            else
            {
                _canCollideRedPlayers = true;
                Movement.AddCollision((int)Global.Type.REDPLAYER);
            }
        }
        public int getRandomNumber()
        {
            return Otter.Rand.Int(1, 9);//always grabs one less than the ending number.
        }
        public void addNewSprites()
        {
            var hMs = 6f;
            var vMs = 6f;
            _spriteMap.Add("standRight", new int[] { 0 }, new float[] { hMs, hMs });
            _spriteMap.Add("standLeft", new int[] { 4 }, new float[] { hMs, hMs });
            _spriteMap.Add("standUp", new int[] { 2 }, new float[] { hMs, hMs });
            _spriteMap.Add("standDown", new int[] { 6 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkRight", new int[] { 0, 1 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkLeft", new int[] { 4, 5 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkUp", new int[] { 2, 3 }, new float[] { vMs, vMs });
            _spriteMap.Add("walkDown", new int[] { 6, 7 }, new float[] { vMs, vMs });
            _spriteMap.Add("hit", new int[] { 8, 8, 8, 8}, new float[] { vMs, vMs });
        }
        public void stopWalkingAnimations()
        {
            if (!_hMove && !_vMove)
            {
                switch (_spriteMap.CurrentAnim)
                {
                    case ("walkLeft"):
                        _spriteMap.Play("standLeft");
                        break;
                    case ("walkRight"):
                        _spriteMap.Play("standRight");
                        break;
                    case ("walkUp"):
                        _spriteMap.Play("standUp");
                        break;
                    case ("walkDown"):
                        _spriteMap.Play("standDown");
                        break;
                    default:
                        break;
                }
            }
        }
        public override void Render()
        {
            base.Render();
            //Collider.Render();
        }
        public void destroy()
        {
            RemoveSelf();
        }
        private enum move
        {
            nothing,
            up,
            upRight,
            right,
            downRight,
            down,
            downLeft,
            left,
            upLeft
        }
    }
}

