﻿using Otter;

namespace LaserBlasterTag.entities.teams
{
    public class RedTeamTitleScreenJunkies : Entity
    {
        private Spritemap<string> _spriteMap;
        private bool isTimeToMove = true;
        private bool stand = false;
        private int rand = 0;
        private int walkTimer = 0;
        private int standTimer = 0;
        private float forcedSpeed = Otter.Rand.Float(.05f, .1f);
        private bool _first = true;
        private bool _canCollideRedPlayers = false;
        public BasicMovement Movement = new BasicMovement(1600, 1600, 1600);
        public RedTeamTitleScreenJunkies(float x, float y)
        {
            X = x; Y = y;
            SetHitbox(8, 8, (int)Global.Type.REDPLAYER);
            Collider.X = 20;
            Collider.Y = 18;
            Axis axis = Axis.CreateArrowKeys();
            Movement.Axis = axis;
            Movement.Axis.AddKeys(Key.W, Key.D, Key.S, Key.A);//you could use this to add your own keys for moving the character! :-)
            Movement.Collider = Collider;
            Movement.AddCollision((int)Global.Type.SOLID);
            AddComponents(axis, Movement);
            _spriteMap = new Spritemap<string>(Assets.REDPLAYER, 46, 56);
            addNewSprites();
            _spriteMap.Play("stand");
            Graphic = _spriteMap;
        }
        public override void Update()
        {
            base.Update();
            if (_first)
            {
                _first = false;
                if (Collider.Collide(X, Y, (int)Global.Type.SOLID) != null)//am i colliding with a solid?
                {
                    Scene.Add(new RedTeamTitleScreenJunkies(Otter.Rand.Int(Global.GAME.Width - 150, Global.GAME.Width - 64), Otter.Rand.Int(8, Global.GAME.Height - 64)));
                    destroy();
                }

            }
            #region Movement
            if (isTimeToMove)
            {
                isTimeToMove = false;
                walkTimer = Otter.Rand.Int(30, 101);
                forcedSpeed = Otter.Rand.Float(.05f, .1f);
                rand = getRandomNumber();
            }
            if (walkTimer > 0)
            {
                walkTimer--;
                switch (rand)
                {
                    case (int)move.up:
                        Movement.Axis.ForceStateY(-forcedSpeed);
                        break;
                    case (int)move.upRight:
                        Movement.Axis.ForceState(forcedSpeed, -forcedSpeed);
                        break;
                    case (int)move.right:
                        Movement.Axis.ForceStateX(forcedSpeed);
                        break;
                    case (int)move.downRight:
                        Movement.Axis.ForceState(forcedSpeed, forcedSpeed);
                        break;
                    case (int)move.down:
                        Movement.Axis.ForceStateY(forcedSpeed);
                        break;
                    case (int)move.downLeft:
                        Movement.Axis.ForceState(-forcedSpeed, forcedSpeed);
                        break;
                    case (int)move.left:
                        Movement.Axis.ForceStateX(-forcedSpeed);
                        break;
                    default://upleft
                        Movement.Axis.ForceState(-forcedSpeed, -forcedSpeed);
                        break;
                }
            }
            if (!stand && walkTimer <= 0)
            {
                stand = true;
                Movement.Axis.ReleaseState();
                standTimer = Otter.Rand.Int(40, 101);
                if (!_canCollideRedPlayers)
                {
                    checkIfCollidingWithRedPlayer();
                }
            }
            if (stand && standTimer > 0)
                standTimer--;
            if (stand && standTimer <= 0)
            {
                stand = false;
                isTimeToMove = true;
            }
            #endregion
        }

        private void checkIfCollidingWithRedPlayer()
        {
            if (Collider.Collide(X, Y, (int)Global.Type.REDPLAYER) != null)
                return;
            else
            {
                _canCollideRedPlayers = true;
                Movement.AddCollision((int)Global.Type.REDPLAYER);
            }
        }
        public int getRandomNumber()
        {
            return Otter.Rand.Int(1, 9);//always grabs one less than the ending number.
        }
        public void addNewSprites()
        {
            var hMs = 6f;//horizontal animation speed
            _spriteMap.Add("stand", new int[] { 0 }, new float[] { hMs, hMs });
        }
        public override void Render()
        {
            base.Render();
            //Collider.Render();
        }
        public void destroy()
        {
            RemoveSelf();
        }
        private enum move
        {
            nothing,
            up,
            upRight,
            right,
            downRight,
            down,
            downLeft,
            left,
            upLeft
        }
    }
}
